﻿using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
// ====
using Eplan.EplApi.ApplicationFramework;
using Eplan.EplApi.Base;
using Eplan.EplApi.Gui;
using Eplan.EplApi.Scripting;

using System.Windows.Forms;
// ====
// ============================================================================== //
// Mit diesem Skript kann ein Schema für die Artikeldatenbank durch einen
// Eintrag in den Projekteigenschaften hier: Zusatzfeld [50] vorausgewählt werden.
// Die Aktivierung kann beim Öffnen des Projekts oder per Button auf der Symbol-
// leiste erfolgen.
//
// V1.0 Basis Version
// Zustazfeld [50] zum festelgen des gewünschten Schemas
// ist Zusatzfeld [50] leer geschieht nichts, es erfolgt auch keine Meldung
// Action, die auch beim Öffnen eines Projekts aufgerufen wird
// Wurde das gewünschte Schema bereits ausgewählt erscheint keine Meldung
//  ///
// 
// ============================================================================== //
namespace Datenbank_umschalten
{
    public class ChangeDBfromProject
    {


        [DeclareAction("ChangeDBfromProject")]
        public void ChangeDB()
        {
            //
            // In diesem Beispiel kann im Zusatzfeld [50] der Projekteigenschaften der Name des Schemas für die Artikeldatenbank eingetragen werden
            string strZusatzfeld50 = PathMap.SubstitutePath("$(PROJPROP_10901_50)"); // Projekteigenschaft Zusatzfeld 50 

            SchemeSetting oSchemeSetting1 = new SchemeSetting();
            Settings oSetting1 = new Settings();
            // "Pfad" für die Benutzereigenschaft in den EPLAN Einstellungen
            string sPath1 = string.Empty;
            sPath1 = "USER.PartSelectionGui.DataSourceScheme";
            oSchemeSetting1.Init(sPath1);            
            string strLastUsedScheme = oSchemeSetting1.GetLastUsed(); // Schreibt das zuletzt genutzte Schema der Artikeldatenbank in eine Variable

            //MessageBox.Show(strZusatzfeld50, "Info:", MessageBoxButtons.OK) ; //Zum Prüfen ob der PathMap korrekt funktioniert
            
            // Ist das Zusatzfeld nicht gefüllt wird das Skript beendet
            if (strZusatzfeld50 == "$(PROJPROP_10901_50)")
            {                
                return;
            }
            else
            {              
                
                MessageBox.Show(strLastUsedScheme);
                // Zunächst wird geprüft, ob der im Zusatzfeld eingetragene Schemaname auch als Schema existiert
                if (oSchemeSetting1.CheckIfSchemeExists(strZusatzfeld50) == true && (strLastUsedScheme != strZusatzfeld50))
                {
                    //MessageBox.Show(String.Format("Das Schema '{0}' ist da!", sSchemeNamePart));
                    // Ist das gewünschte Schema vorhanden wird die Benutzereinstellung entsprechend der Vorgabe gesetzt und mit einer Nachricht bestätigt
                    oSetting1.SetStringSetting(sPath1 + ".LastUsed", strZusatzfeld50, 0);
                    MessageBox.Show(String.Format("Für dieses Projekt wird die Artikeldatenbank: " + strZusatzfeld50 + " genutzt"));
                    return;
                }

                // Ist das Schema nicht angelegt wird eine entsprechende Meldung ausgegeben
                if (oSchemeSetting1.CheckIfSchemeExists(strZusatzfeld50)==false)
                {
                    MessageBox.Show(String.Format("Das gewünschte Schema '{0}' ist nicht vorhanden!", strZusatzfeld50));
                    return;
                }
                
                return;

            }


        }


        [DeclareEventHandler("onActionEnd.String.XPrjActionProjectOpen")]
        public void MyEventHandlerFunctionOnActionStartXPrjActionProjectOpen()
        {
            ChangeDB();

        }
    }
}